
#if !defined(EXCEPT_H_INCLUDED)
#define EXCEPT_H_INCLUDED

#undef TRY
#undef CATCH
#undef THROW
#if defined(__SYMBIAN32__)
  #include <e32std.h>
  typedef int exception;
  #define TRY { TInt leavecode; { TTrap __t; if (__t.Trap(leavecode)==0) {
  #define CATCH(err) TTrap::UnTrap(); }} if (leavecode) { exception err = leavecode;
  #define ENDCATCH } }
  #define THROW(err) User::Leave(err);
#else
#if defined(__palmos__)
  #include <PalmOS.h>
  typedef Int32 exception;
  #define TRY ErrTry
  #define CATCH(err) ErrCatch(err)
  #define ENDCATCH ErrEndCatch
  #define THROW(err) ErrThrow(err)
  #define GUARDED exception local_err; goto local_skip; local_label: THROW(local_err); local_skip:
  #define GUARDTHROW(err) { local_err = err; goto local_label; }
#else
  typedef unsigned long exception;
  #define TRY try
  #define CATCH(err) catch(exception err)
  #define ENDCATCH
  #define THROW(err) throw(err)
#endif
#endif

#define ERRSTR_START const char* ERRSTR(exception err) { const char *err_str;
#define ERRSTR_CLASS(classname) err_str = classname::ExceptionString(err); if (err_str) return err_str;
#define ERRSTR_END return "Unknown error"; }

#endif
