
#include <stdio.h>

#include "except.h"
#include "files.h"

void pdb2rar(const char *src, const char *dst) {
  printf("%s -> %s\n",src,dst);
  CDiskFile rar;
  CPDBfile pdb;
  TRY {
    pdb.OpenRead(src);
    if (pdb.ResDB()) THROW(FILE_FORMAT_ERROR);
    int blocks = pdb.Entries();
    rar.OpenRewrite(dst);
    for (int i=0; i<blocks; i++) {
      char buffer[65536];
      pdb.ReadRecord(i,&buffer);
      rar.Write(&buffer,pdb.GetRecordSize(i));
    }
    pdb.Close();
    rar.Close();
  }
  CATCH(err) {
    pdb.Close();
    rar.Close();
    THROW(err);
  }
}

ERRSTR_START
ERRSTR_CLASS(CDiskFile)
ERRSTR_END

const char *usage = "Usage: pdb2rar input.pdb output.rar\n";

int main(int argc, char *argv[],char *envp[]) {
  if (argc<3) {
    printf(usage);
    return 1;
  }
  bool ret = 0;
  TRY {
    pdb2rar(argv[1],argv[2]);
  }
  CATCH(err) {
    printf("Error: %s\n",ERRSTR(err));
    ret = 1;
  } ENDCATCH
  return ret;
}
